# Create a new personal access token (PAT) for the current user. POST https://app.unleash-instance.example.com/api/admin/user/tokens Content-Type: application/json Creates a new [personal access token](https://docs.getunleash.io/concepts/api-tokens-and-client-keys#personal-access-tokens (PAT) belonging to the current user. Reference: https://docs.getunleash.io/api/create-pat ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Create a new personal access token (PAT) for the current user. version: endpoint_personalAccessTokens.createPat paths: /api/admin/user/tokens: post: operationId: create-pat summary: Create a new personal access token (PAT) for the current user. description: >- Creates a new [personal access token](https://docs.getunleash.io/concepts/api-tokens-and-client-keys#personal-access-tokens (PAT) belonging to the current user. tags: - - subpackage_personalAccessTokens parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '201': description: The resource was successfully created. content: application/json: schema: $ref: '#/components/schemas/patSchema' '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '404': description: The requested resource was not found. content: {} requestBody: description: '#/components/schemas/createPatSchema' content: application/json: schema: $ref: '#/components/schemas/createPatSchema' components: schemas: createPatSchema: type: object properties: description: type: string description: The PAT's description. expiresAt: type: string format: date-time description: The PAT's expiration date. required: - description - expiresAt patSchema: type: object properties: id: type: integer description: >- The PAT's ID. PAT IDs are incrementing integers. In other words, a more recently created PAT will always have a higher ID than an older one. secret: type: string description: >- The token used for authentication. It is automatically generated by Unleash when the PAT is created and that is the only time this property is returned. createdAt: type: string format: date-time description: The date and time of when the PAT was created. seenAt: type: - string - 'null' format: date-time description: >- When the PAT was last seen/used to authenticate with. `null` if it has not been used yet. userId: type: integer description: The ID of the user this PAT belongs to. description: type: string description: The PAT's description. expiresAt: type: string format: date-time description: The PAT's expiration date. required: - id - createdAt - description - expiresAt ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/user/tokens" payload = { "description": "user:xyzrandomstring", "expiresAt": "2023-04-19T08:15:14.000Z" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/user/tokens'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"description":"user:xyzrandomstring","expiresAt":"2023-04-19T08:15:14.000Z"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/user/tokens" payload := strings.NewReader("{\n \"description\": \"user:xyzrandomstring\",\n \"expiresAt\": \"2023-04-19T08:15:14.000Z\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/user/tokens") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"description\": \"user:xyzrandomstring\",\n \"expiresAt\": \"2023-04-19T08:15:14.000Z\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/user/tokens") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"description\": \"user:xyzrandomstring\",\n \"expiresAt\": \"2023-04-19T08:15:14.000Z\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/user/tokens', [ 'body' => '{ "description": "user:xyzrandomstring", "expiresAt": "2023-04-19T08:15:14.000Z" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/user/tokens"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"description\": \"user:xyzrandomstring\",\n \"expiresAt\": \"2023-04-19T08:15:14.000Z\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "description": "user:xyzrandomstring", "expiresAt": "2023-04-19T08:15:14.000Z" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/user/tokens")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```